<template src="./create.htm"></template>

<script>

    import Vue from 'vue';
    import Info from './components/info/InfoComponent.vue';

    import { breadcrumbsMixin } from '../../../mixins/breadcrumbsMixin.js';
    import HandleEntityMixin from '../../../mixins/entities/handleEntityMixin.js';
    import ValidationErrorsMixin from '../../../mixins/validationErrorsMixin.js';

    Vue.component('info', Info);

    export default {

        data() {

            return {

            }
        },

        mixins: [
            breadcrumbsMixin,
            HandleEntityMixin,
            ValidationErrorsMixin
        ],

        methods: {

            /**
             * Create attribute from store, and redirect to given action (index, create).
             **/
            createAttribute(action) {

                this.handleEntity('attribute', action, route('admin.attributes.store'));
            },


            /**
             * Remove all saved attributes data from attribute.
             */
            removeAttribute() {

                this.$store.dispatch('setDefaultAttribute')
            },


            /**
             * Prepare attribute object for store request.
             */
            createEntityRequestObject() {

                return createRequestObject(this.attribute);
            }
        },

        computed: {

            /**
             * Get currently attribute from store.
             */
            attribute() {

                return this.$store.state.attribute;
            }
        },

        /**
         * Set attribute in store to default state. In order to always have empty fields on create page.
         */
        beforeDestroy() {

            this.removeAttribute();
        }
    }

</script>